do
   local MyUnitIdTable = {
		'ch_bea01',
		'ch_def01',
		'ch_def02',
		'ch_et01',
		'ch_fas01',
		'ch_fas02',
		'ch_fas03',
		'ch_mul01',
		'ch_mul02',
		'ch_mul03',
		'ch_mul04',
		'ch_rng01',
		'ch_rng02',
		'ch_spl01',
		'ch_spl02',
		'ch_spl04',
		'ch_sta01',
		'ch_sta02',
		'ch_sta03',
		'ch_upg01',
		'ch_upg02',
		'ch_upg03',
		'ch_upg04',
		'ch_upg05',
		'ch_upg11',
		'ch_upg12',
		'ch_upg13',
		'ch_upg14',
		'ch_upg15',
   }
   --unit icon must be in /icons/units/. Put the full path to the /icons/ folder in here - note no / on the end!
   local MyIconPath = "/mods/Turret Compilation"

   local oldFileNameFn = GetUnitIconFileNames
   
   local function IsMyUnit(bpid)
      for i, v in MyUnitIdTable do
         if v == bpid then
            return true
         end
      end
      return false
   end
   
   function GetUnitIconFileNames(blueprint)
      if IsMyUnit(blueprint.Display.IconName) then
         local iconName = MyIconPath .. "/icons/units/" .. blueprint.Display.IconName .. "_icon.dds"
         local upIconName = MyIconPath .. "/icons/units/" .. blueprint.Display.IconName .. "_icon.dds"
         local downIconName = MyIconPath .. "/icons/units/" .. blueprint.Display.IconName .. "_icon.dds"
         local overIconName = MyIconPath .. "/icons/units/" .. blueprint.Display.IconName .. "_icon.dds"
         
         if DiskGetFileInfo(iconName) == false then
            WARN('Blueprint icon for unit '.. blueprint.Display.IconName ..' could not be found, check your file path and icon names!')
            iconName = '/textures/ui/common/icons/units/default_icon.dds'
            upIconName = '/textures/ui/common/icons/units/default_icon.dds'
            downIconName = '/textures/ui/common/icons/units/default_icon.dds'
            overIconName = '/textures/ui/common/icons/units/default_icon.dds'
         end
         return iconName, upIconName, downIconName, overIconName
      else
         return oldFileNameFn(blueprint)
      end
   end
end