local CLOATacticalChildMissileProjectile = import('/lua/cybranprojectiles.lua').CLOATacticalChildMissileProjectile
local EffectTemplate = import('/lua/EffectTemplates.lua')
local SingleBeamProjectile = import('/lua/sim/defaultprojectiles.lua').SingleBeamProjectile

ch_wpn_missile03 = Class(CLOATacticalChildMissileProjectile) {

	FxImpactUnit = EffectTemplate.TAPDSHitUnit01,
    FxImpactLand = EffectTemplate.TAPDSHit01,
    FxImpactProp = EffectTemplate.TAPDSHit01,
	
    OnCreate = function(self)
        CLOATacticalChildMissileProjectile.OnCreate(self)
        self:SetCollisionShape('Sphere', 0, 0, 0, 2.5)
		
		self:TrackTarget(true)
        self:SetTurnRate(130)
        self:SetMaxSpeed(15)
        self:SetAcceleration(5)
		
		self.HasTarget = false
		self.CurrentTarget = nil
		
		local projectile = self
		local army = self:GetArmy()
		
		local FindTargetThread = ForkThread(function(self)
			while not (projectile:BeenDestroyed()) do
				if not projectile.HasTarget then
					local radius = 10
					local position = projectile:GetPosition()
					local x1 = position.x - radius
					local z1 = position.z - radius
					local x2 = position.x + radius
					local z2 = position.z + radius
					local UnitsinRec = GetUnitsInRect( Rect(x1, z1, x2, z2) )
						
					local prevDistance = radius
					local newTarget = nil
					
					if not UnitsinRec then
						
					else
					
						for k, v in UnitsinRec do
							local dist = VDist3(position, v:GetPosition())
							if (IsEnemy(army, v:GetArmy())) and (not (v:IsDead())) and (dist <= radius) then
								if dist < prevDistance then
									projectile.HasTarget = true
									projectile.CurrentTarget = v
									prevHealthPercentage = dist
								end
							end
						end
						
						if projectile.HasTarget == true then
							projectile:SetNewTarget(projectile.CurrentTarget)
						end
					end
					
				else
					if projectile.CurrentTarget:IsDead() then
						projectile.HasTarget = false
					end
				end
				
				WaitSeconds(0.15)
			end
			KillThread(self)
		end)
    end,
	
    OnImpact = function(self, targetType, targetEntity)
        SingleBeamProjectile.OnImpact(self, targetType, targetEntity)
    end,
}
TypeClass = ch_wpn_missile03